VERSION 5.00
Begin VB.Form frmIcons 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "ExtrractIcons"
   ClientHeight    =   4275
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5265
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   285
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   351
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton cmdAide 
      Caption         =   "Aide"
      Height          =   375
      Left            =   120
      TabIndex        =   6
      Top             =   3840
      Width           =   615
   End
   Begin VB.CommandButton cmdPurge 
      Caption         =   "Purge"
      Height          =   375
      Left            =   960
      TabIndex        =   5
      Top             =   3840
      Width           =   975
   End
   Begin VB.CommandButton cmdQuit 
      Cancel          =   -1  'True
      Caption         =   "Quitter"
      Height          =   375
      Left            =   4200
      TabIndex        =   2
      Top             =   3840
      Width           =   975
   End
   Begin VB.CommandButton cmdRep 
      Caption         =   "Rpertoire"
      Height          =   375
      Left            =   2040
      TabIndex        =   0
      Top             =   3840
      Width           =   975
   End
   Begin VB.ListBox lstOut 
      Height          =   2205
      Left            =   120
      TabIndex        =   4
      Top             =   1440
      Width           =   5055
   End
   Begin VB.ListBox lstRep 
      Height          =   1230
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   5055
   End
   Begin VB.CommandButton cmdExtract 
      Caption         =   "Extraire"
      Default         =   -1  'True
      Height          =   375
      Left            =   3120
      TabIndex        =   1
      Top             =   3840
      Width           =   975
   End
End
Attribute VB_Name = "frmIcons"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False


Option Explicit

Private Const Extensions = "exe;dll;ocx"
Private Const TabStop = 180

Private Sub cmdAide_Click()
    MsgBox "* Les icnes des fichiers (extensions " & Extensions & ") sont crs dans le rpertoire de l'application et sont de la forme icon????.ico o ???? reprsente un numro d'ordre." & vbCrLf & vbCrLf & _
           "* Un fichier de log est cr dans le rpertoire de l'application (" & LogFile & ") et est relu pour ne pas extraire plusieurs fois la mme icne (le bouton Purge vide ce fichier)." & vbCrLf & vbCrLf & _
           "* Click sur la liste suprieure pour enlever un rpertoire." & vbCrLf & vbCrLf & _
           "* Double click sur la liste infrieure pour vider l'affichage." & vbCrLf & vbCrLf & _
           "Attention! l'utilisation de ce programme est  vos risques et prils. L'auteur dcline toute responsabilit quant  une perte de donnes ou un endommagement du systme. Lire la license fournie avec les sources. Voir http://www.gnu.org/copyleft/gpl.html", vbInformation
End Sub

Private Sub cmdExtract_Click()
    Dim i   As Integer
    
    'Met le pointeur de la souris en forme de sablier
    Screen.MousePointer = vbHourglass
    
    'Extrait les icnes
    GetExtracted
    
    For i = 0 To lstRep.ListCount - 1
        AllIcons lstRep.List(i)
    Next
    
    'Opration termine
    Debug.Print "Fini !"
    Screen.MousePointer = vbDefault 'remet le pointeur en curseur normal
End Sub



Private Sub cmdPurge_Click()
    On Error Resume Next
    Kill App.path & LogFile
    On Error GoTo 0
End Sub

Private Sub cmdQuit_Click()

Unload Me   'Ferme la feuille
    
End Sub

Private Sub cmdRep_Click()

    Dim bi          As BROWSEINFO
    Dim IDL         As ITEMIDLIST
    Dim pidl        As Long
    Dim r           As Long
    Dim pos         As Integer
    Dim spath       As String
    Dim lblSelected As String
    
    bi.hOwner = Me.hWnd
    bi.pidlRoot = 0&
    bi.lpszTitle = "Selectionnez le rpertoire dsir:"
    bi.ulFlags = BIF_RETURNONLYFSDIRS '+ BIF_STATUSTEXT
    pidl& = SHBrowseForFolder(bi)
    spath = Space(512)
    r = SHGetPathFromIDList(ByVal pidl, ByVal spath)
    If r Then
        pos = InStr(spath, Chr(0))
        lblSelected = Left(spath, pos - 1)
        
        lstRep.AddItem lblSelected
    End If
    
End Sub

Private Sub Form_Load()

'**********************************************************
'*
'*NOM : Dumpico
'*
'*AUTEUR : Ren DEVICHI
'*         devichi@worldnet.fr
'*
'*Code trouv sur "Le petit monde de Visual Basic"
'*                 http://vbasic.citeweb.net
'*
'*DESCRIPTION :
'*Permet d'extraire les icnes contenues dans tous les
'*fichiers d'un rpertoire, afin de les stocker dans ce
'*mme rpertoire sous forme de fichiers .ico
'*
'**********************************************************


    AddTabInList Me, lstOut, TabStop
    
'    lstRep.AddItem "c:\program files\microsoft office\office\"
'    lstRep.AddItem "c:\winnt"
'    lstRep.AddItem "c:\winnt\system32"
'    lstRep.AddItem "c:\DevStudio\VC\bin"
'    lstRep.AddItem "c:\DevStudio\SharedIDE\bin"
'    lstRep.AddItem "c:\DevStudio\VB"
End Sub

Private Sub lstOut_DblClick()
    lstOut.Clear
End Sub

Private Sub lstRep_Click()
    If lstRep.ListIndex <> -1 Then lstRep.RemoveItem lstRep.ListIndex
End Sub


Private Sub AllIcons(ByVal path As String)
    Dim s           As String
    Dim ext         As String
    Dim i           As Integer
    Dim nIconsAvant As Integer
    
    
    If Right(path, 1) <> "\" Then path = path & "\"
    
    ext = Extensions
    
    Do While True
        i = InStr(ext, ";")
        If i = 0 Then
            s = Dir(path & "*." & ext)
        Else
            s = Dir(path & "*." & Left(ext, i - 1))
        End If
        ext = Mid(ext, i + 1)
        Do Until s = ""
            Debug.Print "Extracting " & s & "..."
            
            lstOut.AddItem LimitWidth(path & s, TabStop)
            lstOut.ListIndex = lstOut.ListCount - 1
            lstOut.Refresh
            
            nIconsAvant = nIcons
            ExtractIcons path & s
            
            lstOut.List(lstOut.ListIndex) = lstOut.List(lstOut.ListIndex) & vbTab & nIcons - nIconsAvant & " icne" & IIf(nIcons - nIconsAvant > 1, "s", "")
            s = Dir()
        Loop
        
        If i = 0 Then Exit Do
    Loop

End Sub


Private Function LimitWidth(ByRef s As String, ByVal w As Long) As String
    Dim i   As Integer
    Dim p   As Integer
    Dim nfo As String
    Dim ws  As Long
    
    ws = Me.TextWidth(s)
    
    If ws >= w Then
        nfo = s
        p = IIf(Mid(nfo, 2, 1) = ":", 2, 0)
        If Mid(nfo, p + 1, 1) = "\" Then p = p + 1
        
        nfo = Left(nfo, p) & "...\" & Mid(nfo, p + 1)
        Do While Me.TextWidth(nfo) >= w
            i = InStr(p + 6, nfo, "\")
            If i = 0 Then Exit Do
            nfo = Left(nfo, 7) & Mid(nfo, i + 1)
        Loop
    End If
    

    If w > ws Or Me.TextWidth(nfo) > ws Then
        LimitWidth = s
    Else
        LimitWidth = nfo
    End If
End Function

